exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

var EVAL_FUNC_NAME_RE = /^(eval|setTimeout|setInterval)$/;

// Transform:
// eval(script); setTimeout(script); setInterval(script);  -->
// eval(__proc$Script(script)); setTimeout(__proc$Script(script)); setInterval(__proc$Script(script));

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.CallExpression],

    condition: function (node) {
        if (!node.arguments.length) return false;

        // eval(), setTimeout(), setInterval()
        if (node.callee.type === _toolsEsotope.Syntax.Identifier && EVAL_FUNC_NAME_RE.test(node.callee.name)) return true;

        // obj.eval(), obj['eval'](),
        // obj.setTimeout(), obj['setTimeout'](),
        // obj.setInterval(), obj['setInterval']()
        return node.callee.type === _toolsEsotope.Syntax.MemberExpression && EVAL_FUNC_NAME_RE.test(node.callee.property.name || node.callee.property.value);
    },

    run: function (node) {
        node.arguments[0] = _nodeBuilder.createProcessScriptMethCall(node.arguments[0]);

        return null;
    }
};
module.exports = exports.default;